#!/usr/bin/perl

require "./conf.pl";

$len = int ( $fs / $fc * 2 );

$dt = 1.0 / $fs;

sub filt {
    my $len = $_[0];
    my @tap = ();

    for ( my $i = 0; $i < $len; ++$i ) {
	my $t = $i * $dt;
	$tap[$i] = cos ( 2*3.14159265*$fc*$t );
    }
    
    return @tap;
}


sub calc_out {
    my $tap = $_[0];
    my $amp = $_[1];
    my $len = $_[2];

    my $s = 0;
    for ( my $i = 0; $i < $len; ++$i ) {
	$s += $tap->[$i] * $amp->[$i];
    }

    return $s / $len;
}

@amp = filt ( $len );

for (;;) {
    exit 0 if eof(STDIN);
    $c = ( ord( getc() ) - 128 )/127;    
    $tap[$len - 1] = $c;

    $a = calc_out ( \@tap, \@amp, $len );
    printf "%f\n", $a;
    shift @tap;
}
