#!/usr/bin/perl

require "./conf.pl";

$code = 0;

sub set_code {
    my $b = $_[0];
    $code = ( $code << 1 )  | $b;
    printf STDERR "code = %08x\n", $code;
}


# エッジ検出
sub edge_detect {
    for (;;) {
	exit 0 if eof(STDIN);
	my $a = <>;
	my $b = ( $a > 0 ) ? 1 : 0;
	$tap[$ovs+2] = $b;
	my $c = shift @tap;
	last if $c != $tap[0];
    }
    set_code ( $tap[int($ovs/2)] );
}


# １シンボル分タップ充填
sub fill_symbol {
    my $o = $_[0];

    for ( $i = 0; $i < $o; ++$i ) {
	exit 0 if eof(STDIN);
	$a = <>;
	$b = ( $a > 0 ) ? 1 : 0;
	$tap[$ovs+2] = $b;
	$c = shift @tap;
    }
    set_code ( $tap[int($ovs/2)] );
}

edge_detect();
fill_symbol($ovs);
for (;;) {
    if ( $tap[$ovs-2] != $tap[$ovs-1] ) {
	fill_symbol ( $ovs - 1 );
    } elsif ( $tap[$ovs-1] != $tap[$ovs] ) {
	fill_symbol ( $ovs );
    } elsif ( $tap[$ovs] != $tap[$ovs+1] ) {
	fill_symbol ( $ovs + 1 );
    } else {
	fill_symbol ( $ovs );
    }
}


